=== modified file 'lib/canonical/config/schema-lazr.conf'
--- lib/canonical/config/schema-lazr.conf	2011-07-07 10:46:09 +0000
+++ lib/canonical/config/schema-lazr.conf	2011-07-07 11:39:17 +0000
@@ -1270,9 +1270,15 @@
 homepage_recent_posts_count: 6
 
 [launchpad_session]
+# The database connection string.
 # datatype: pgconnection
 database: none
 
+# The dbuser setting is added to the connection string, to allow configs
+# to easily override this particular setting.
+# datatype: string
+dbuser: session
+
 # The id of the cookie used to store the session token.
 # datatype: string
 cookie: launchpad
@@ -1284,8 +1290,6 @@
 dbhost: none
 # datatype: string
 dbname: session_prod
-# datatype: string
-dbuser: session
 
 
 [librarianlogparser]

=== modified file 'lib/canonical/launchpad/webapp/adapter.py'
--- lib/canonical/launchpad/webapp/adapter.py	2011-07-06 20:03:12 +0000
+++ lib/canonical/launchpad/webapp/adapter.py	2011-07-07 11:39:17 +0000
@@ -52,6 +52,7 @@
     DatabaseConfig,
     )
 from canonical.database.interfaces import IRequestExpired
+from canonical.database.postgresql import ConnectionString
 from canonical.launchpad.interfaces.lpstorm import (
     IMasterObject,
     IMasterStore,
@@ -514,8 +515,14 @@
     name = 'session'
 
     def raw_connect(self):
-        self._dsn = config.launchpad_session.database
-        if not self._dsn:
+        if config.launchpad_session.database is not None:
+            dsn = ConnectionString(config.launchpad_session.database)
+            dsn.user = config.launchpad_session.dbuser
+            self._dsn = str(dsn)
+        else:
+            # This is fallback code for old config files. It can be
+            # removed when all live configs have been updated to use the
+            # 'database' setting instead of 'dbname' + 'dbhost' settings.
             self._dsn = 'dbname=%s user=%s' % (config.launchpad_session.dbname,
                                             config.launchpad_session.dbuser)
             if config.launchpad_session.dbhost:

